'' Test Parallax Mouse.spin
'' Displays Parallax mouse X, Y, and Scroll button coordinates along with the scroll wheel,
'' right and left button states in the Parallax Serial Terminal.

'' See 28060-PS2Adapter.pdf for schematics and instructions. 

CON

  _clkmode = xtal1 + pll16x                      ' System clock settings
  _xinfreq = 5_000_000
                                                 
  HOME   = 1                                     ' Parallax Serial Terminal constants 
  CRSRXY = 2
  CR     = 13
  CLREOL = 11
  CLS    = 16
 
VAR

  long deltaX, deltaY, readCount

OBJ

  mouse : "Mouse140415a"                                ' Declare Mouse object
  debug : "FullDuplexSerial"                     ' Declare FullDuplexSerial object
  
PUB MouseDisplay | mousex, mousey, mousez, mousebtns

  mouse.start(24, 25, @deltaX)                     ' Start mouse
  debug.start(31, 30, 0, 115_200)                  ' Start serial connection

  waitcnt(clkfreq + cnt)                         ' Wait 1 s before starting

  ' Display static text.
  debug.str(String(CLS, "Mouse", CR, "x = ", CR, "y = ", CR, "scroll = ", CR, "CRL", CR, CR))
  debug.str(String(CR, "delta x = ", CR, "delta y = ", CR, "readCount = ", HOME))

  repeat
    mousex := mouse.abs_x
    mousey := mouse.abs_y
    mousez := mouse.abs_z
    mousebtns := mouse.buttons  
 
    debug.str(string(CRSRXY, 4, 1))              ' Display mouse data    
    debug.dec(mousex)
    debug.str(string(CLREOL, CRSRXY, 4, 2))
    debug.dec(mousey)
    debug.str(string(CLREOL, CRSRXY, 9, 3))
    debug.dec(mousez)
    debug.str(string(CLREOL, CR, CR))
    debug.bin(mouse.buttons, 5)
    debug.str(string(CLREOL, CRSRXY, 10, 7))
    debug.dec(deltaX)
    debug.str(string(CLREOL, CRSRXY, 10, 8))
    debug.dec(deltaY)
    debug.str(string(CLREOL, CRSRXY, 12, 9))
    debug.dec(readCount)
    